/*
 * Created on Jun 2, 2004
 *
 */
package archstudio.comp.cake;

import java.util.Calendar;

/**
 * @author Chris
 *
 */
public class CakeAnnotationThing extends LayerableFloatingLabel
{

	/**
	 * 
	 */
	public CakeAnnotationThing(String versionName, String layerName)
	{
		super();
		setVersion(versionName);
		setLayer(layerName);		
		setAnnotationLabel();		
		setMaximumWidth(200);
	}
	
	protected CakeAnnotationThing(CakeAnnotationThing copyMe)
	{
		super(copyMe);
	}

	public Object clone() throws CloneNotSupportedException
	{
		CakeAnnotationThing m = new CakeAnnotationThing(this);
		return m;
	}
	
	public String getPeerClassname()
	{
		return "archstudio.comp.cake.CakeAnnotationThingPeer";
	}
	
	private void setAnnotationLabel()
	{
		// Create a label with account name and date on the header line
		String header = "";
		String userName = java.lang.System.getProperty("user.name");
		if(userName != null)
		{
			header += userName;
		}
		Calendar calendar = Calendar.getInstance();
		int month = calendar.get(Calendar.MONTH) + 1;
		int date = calendar.get(Calendar.DATE);
		int year = calendar.get(Calendar.YEAR);
		
		header += "                " + month + "/" + date + "/" + year + "\n";				 
		setHeader(header);
		
		setLabel("");		
	}
	
	protected void setHeader(String header)
	{
		setProperty("annotationHeader", header);
	}
	
	protected String getHeader()
	{
		return (String)getProperty("annotationHeader");
	}
		
	protected void setMinimumWidth(int width)
	{
		setProperty("minWidth", width);
	}
	
	protected int getMinimumWidth()
	{
		return getIntProperty("minWidth");
	}
	
	protected void setMaximumWidth(int width)
	{
		setProperty("maxWidth", width);
	}
	
	protected int getMaximumWidth()
	{
		return getIntProperty("maxWidth");
	}
	
	public String getToolTipText()
	{
		return "Annotation " + getLabel() + 
			" - Version " + getVersion() + " Layer: " + getLayer();
	}
}
