package archstudio.comp.cake;

/*  (swing1.1) */
 
//import java.io.*;
import java.awt.Color;
import java.util.*;
import javax.swing.tree.*;
//import jp.gr.java_conf.tame.swing.attribute.*;


/**
 * @version 1.0 01/11/99
 */
public class CheckNode extends DefaultMutableTreeNode {

  public final static int SINGLE_SELECTION = 0;
  public final static int DIG_IN_SELECTION = 4;
  protected int selectionMode;
  protected boolean isSelected;
  protected boolean isSelected2;
  
  //Stuff for working with the tree model
  static final int COMPONENT_LAYER = 0;
  static final int CONNECTOR_LAYER = 1;
  static final int LINK_LAYER = 2;
  static final int ANNOTATION_LAYER = 3;
  static final int VERSION = 4;
  private String nodeID;
  private boolean isVersion;
  private int layerType;
  private TreeLogic treeLogic;
  private Color color;

  public CheckNode(TreeLogic treeLogic) {
    this(null, treeLogic);
  }
  
  public CheckNode(Object userObject, TreeLogic treeLogic) {
    this(userObject, true, false, false, treeLogic);
  }

  public CheckNode(Object userObject, boolean allowsChildren
                                    , boolean isSelected, boolean isSelected2
                                    , TreeLogic treeLogic) {
	this(userObject, allowsChildren, isSelected, isSelected2, "0", 0, false, treeLogic, Color.BLACK);
  }
  
  //This is the one that will be used most often 
  public CheckNode(Object userObject, String nodeID
  					, int layerType, boolean isVersion, TreeLogic treeLogic, Color color){
	this(userObject, true, true, true, nodeID, layerType, isVersion, treeLogic, color);
  }
  
  public CheckNode(Object userObject, boolean allowsChildren,
  								boolean isSelected, boolean	isSelected2,
								String nodeID, int layerType,
								boolean isVersion, TreeLogic treeLogic, Color color) {
	super(userObject, allowsChildren);
	this.isSelected = isSelected;
	this.isSelected2 = isSelected2;
	setSelectionMode(DIG_IN_SELECTION);
	this.nodeID = nodeID;
	this.isVersion = isVersion;
	this.layerType = layerType;
	this.treeLogic = treeLogic;
	this.color = color;
  }


  public void setSelectionMode(int mode) {
    selectionMode = mode;
  }

  public int getSelectionMode() {
    return selectionMode;
  }
  
  public String getNodeID(){
	return nodeID;
  }
  
  public boolean getIsVersion(){
  	return isVersion;
  }
  
  public String getName(){
	return (String)userObject;
  }
  
  public Color getColor(){
  	return color;
  }
  
  public void setColor(Color newColor){
	color = newColor;
  }
  
  public void setName(String newName){
	userObject = newName;
  }

  public void setSelected(boolean isSelected) {
    if(this.isSelected != isSelected){
        this.isSelected = isSelected;
		treeLogic.setVisible(nodeID, isSelected);
	    if (children != null) {
    	  Enumeration enum = children.elements();      
      	  while (enum.hasMoreElements()) {
        	CheckNode node = (CheckNode)enum.nextElement();
        	node.setSelected(isSelected);
        	treeLogic.setVisible(node.getNodeID(), isSelected);
          }
		}
    }
  }
  
  public void setSelected2(boolean isSelected2) {
	if(this.isSelected2 != isSelected2){
		this.isSelected2 = isSelected2;
		treeLogic.setEditable(nodeID, isSelected2);
		if (children != null) {
		  	Enumeration enum = children.elements();      
	  		while (enum.hasMoreElements()) {
				CheckNode node = (CheckNode)enum.nextElement();
				node.setSelected2(isSelected2);
				treeLogic.setEditable(node.getNodeID(), isSelected2);
			}
		}
	}
  }
  
  //I know it is lame, but this function just sets this node's selection
  //instead of it and its childrens
  public void setJustMySelected(boolean isSelected){
	if(this.isSelected != isSelected){
  		this.isSelected = isSelected;
		treeLogic.setVisible(getNodeID(), isSelected);
	}
  }
  
  public void setJustMySelected2(boolean isSelected2){
	if(this.isSelected2 != isSelected2){
		this.isSelected2 = isSelected2;
		treeLogic.setVisible(getNodeID(), isSelected2);
	}
  }
  
  public boolean isSelected() {
    return isSelected;
  }
  
  public boolean isSelected2() {
	return isSelected2;
  }
  
  public int getType(){
	return layerType;
  }


  // If you want to change "isSelected" by CellEditor,
  /*
  public void setUserObject(Object obj) {
    if (obj instanceof Boolean) {
      setSelected(((Boolean)obj).booleanValue());
    } else {
      super.setUserObject(obj);
    }
  }
  */

}


