package archstudio.comp.cake;

/* (swing1.1) */
//package jp.gr.java_conf.tame.swing.examples;

//import java.util.*;
import java.awt.BorderLayout;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JLabel;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.border.Border;

//import jp.gr.java_conf.tame.swing.tree.*;

public class CheckNodeTreeExample extends JPanel implements CheckNodeTreeWrapper {

  protected DynamicTree tree;
  ICakeModelWrapper model;
  
  public CheckNodeTreeExample(ICakeModelWrapper model, TreeLogic treeLogic, VersionColorMap colorMap) 
  {
	tree = new DynamicTree(model, treeLogic, colorMap);
	populateTree(tree);
    
	JScrollPane sp = new JScrollPane(tree);
    
    setLayout(new BorderLayout());
    add(sp, BorderLayout.CENTER);
	add(new TopIcons(this), BorderLayout.NORTH);
	setPreferredSize(new Dimension(225, 300));
	this.model = model;
  }
  
  public void populateTree(DynamicTree treePanel) {
	String p1Name = new String("Version 1");
	String p2Name = new String("Version 2");
	String c1Name = new String("Components");
	String c2Name = new String("Connectors");

	CheckNode p1, p2;
/*
	p1 = treePanel.addObject(null, p1Name);
	p2 = treePanel.addObject(null, p2Name);
	treePanel.addObject(p1, c1Name);
	treePanel.addObject(p1, c2Name);
	treePanel.addObject(p2, c1Name);
	treePanel.addObject(p2, c2Name);
*/	
	treePanel.treeModel.reload();
  }
  
  //* * * * * * * * * * * * * * * * * * * *
  //Functions called by buttons (passed to tree)
  //* * * * * * * * * * * * * * * * * * * *
  public void newClicked()
  {
	modelAddVersion();
  }
      
  public void addClicked(){
	String layerName = "Default";
	int layerType = 0;
	
	AddDialog addDialog = new AddDialog(this);
	//modelAddLayer(layerName, layerType);
  }
  
  //Temporary function for the addDialog to call
  public void dialogAdd(String newName, int newType){
  	tree.addObject(newName);
  }
  	
  public void deleteClicked(){
  	if(tree.nullSelected())
  		return;  	
	
	//Building dialog box feedback
	String name = tree.getSelectedName();
	boolean versionBoolean = tree.getSelectedIsVersion();
	String versionString = new String("layer");
	if (versionBoolean)
		versionString = new String("version");
	int n = JOptionPane.showConfirmDialog(
		this,
		"Are you sure you want to delete the "+
		versionString+ " "+name+"?",
		"Confirm Delete",
		JOptionPane.YES_NO_OPTION);
	
	//If they said that they would like to delete the layer
	if(n == JOptionPane.YES_OPTION)
	{
		if(tree.getSelectedIsVersion())
			modelRemoveVersion();
		else
			modelRemoveLayer();
	}
  }
  
  public void copyVersionClicked(){
  	modelCopyVersion();
  }
  
  //* * * * * * * * * * * * * * * * * * * *
  //Functions (later) called by buttons (passed to model)
  //These call the functions on a ICakeTreeWrapper instance: model
  //* * * * * * * * * * * * * * * * * * * *
  
  //Right now this just creates a layer with a default name and type 
  void modelAddLayer(String layerName, int layerType)
  {
	model.addLayer(layerName, layerType, tree.getSelectedVersionID());
  }  
  void modelCopyVersion()
  {
	model.copyVersion(tree.getSelectedVersionID());
  }
  void modelAddVersion()
  {
	model.addVersion();
  }
  void modelRemoveLayer()
  {
	model.removeLayer(tree.getSelectedLayerID());
  }
  void modelRemoveVersion()
  {
	model.removeVersion(tree.getSelectedLayerID());
  }

  
  //* * * * * * * * * * * * * * * * * * * *
  //Functions called by the CakeModel (passed to tree)
  //These are the functions of CheckNodeTreeWrapper
  //* * * * * * * * * * * * * * * * * * * *
  
  //Adds a layer with the specified name, ID and type. The new layer is added
  //to the version specified by versionID
  public void addLayer(String name, String nodeID, int layerType, String versionID){
	tree.addLayer(name, nodeID, layerType, versionID);
  }
  //Removes the layer with the specified layerID (versions may also be removed via this method
  public void removeLayer(String layerID){
  	tree.removeLayer(layerID);
  } 
  //Adds a new version with the specified name and nodeID 
  public void addVersion(String name, String nodeID){
  	tree.addVersion(name, nodeID);
  }
  //Returns the name of the layer that has the given nodeID
  public String getName(String nodeID){
  	return tree.getName(nodeID);
  }
  //Sets the name of the node specified by the id to the name specified
  public void setName(String name, String nodeID){
  	tree.setName(name, nodeID);
  	tree.repaint();
  	
  }
  //Removes the version with the specified nodeID (functionally the same as removeLayer)
  public void removeVersion(String nodeID){
  	removeLayer(nodeID);
  }
  
  public String getSelectedLayerID(){
	return tree.getSelectedLayerID();
  }
  
  public int getSelectedLayerType(){
	return tree.getSelectedType();
  }
  
  public boolean getSelectedIsVersion(){
	return tree.getSelectedIsVersion();
  }
  
  public boolean getIsEditable(String nodeID){
  	return tree.getIsEditable(nodeID);
  }
}


  //Handles the top bar of the window
  class TopIcons extends JPanel implements ActionListener {
	CheckNodeTreeExample tree;
  	
  	//Constructor  	
  	TopIcons(CheckNodeTreeExample tree){
  		this.tree = tree;
  		Border line;
  		
		//NewButton stuff
		JButton newButton = new JButton(createImageIcon("img\\new.gif"));
		newButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				newClicked();
			}  		
		});
		line = BorderFactory.createRaisedBevelBorder();
		newButton.setBorder(line);
		newButton.setToolTipText("Add a new version");
		newButton.setPreferredSize(new Dimension(28,28));
  		
  		//Addbutton stuff
  		JButton addButton = new JButton(createImageIcon("\\img\\new_layer.gif"));
  		addButton.addActionListener(new ActionListener() {
  			public void actionPerformed(ActionEvent ae) {
				addClicked();
  			}  		
  		});
		line = BorderFactory.createRaisedBevelBorder();
		addButton.setBorder(line);
		addButton.setToolTipText("Add a layer to this version");
		addButton.setPreferredSize(new Dimension(28,28));
		
		//Deletebutton stuff
		JButton deleteButton = new JButton(createImageIcon("\\img\\delete.gif"));
		deleteButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				deleteClicked();
			}  		
		});
		line = BorderFactory.createRaisedBevelBorder();
		deleteButton.setBorder(line);
		deleteButton.setToolTipText("Delete selected layer");
		deleteButton.setPreferredSize(new Dimension(28,28));
		
		//CopyVersionbutton stuff
		JButton copyVersionButton = new JButton(createImageIcon("\\img\\add.gif"));
		copyVersionButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent ae) {
				copyVersionClicked();
			}  		
		});
		line = BorderFactory.createRaisedBevelBorder();
		copyVersionButton.setBorder(line);
		copyVersionButton.setToolTipText("Copy Selected Version");
		copyVersionButton.setPreferredSize(new Dimension(28,28)); 		
  		
  		//Filler labels to push the icons over
		JLabel filler = new JLabel();
		filler.setPreferredSize(new Dimension(CheckRenderer.getColumnX()-95, 12));
		JLabel filler2 = new JLabel();
		filler2.setPreferredSize(new Dimension(1, 12));
  		
		//Column icons
		setLayout(new FlowLayout(FlowLayout.LEADING));
		JLabel eyeIcon = new JLabel(createImageIcon("img\\eye.gif"));
		JLabel brushIcon = new JLabel(createImageIcon("img\\brush.gif"));
		eyeIcon.setPreferredSize(new Dimension(11, 12));
		brushIcon.setPreferredSize(new Dimension(11, 12));
  		
  		add(newButton);
  		add(addButton);
		add(deleteButton);
		add(copyVersionButton);
		add(filler);  		
  		add(eyeIcon);
		add(filler2);
		add(brushIcon);
		setPreferredSize(new Dimension(100,36));	
  	}
  	
  	//These just pass the calls to the appropriate functions in the tree
  	private void newClicked(){
  		tree.newClicked();
  	}  	
	private void addClicked(){
		tree.addClicked();
	}	
	private void deleteClicked(){
		tree.deleteClicked();
	}
	private void copyVersionClicked(){
		tree.copyVersionClicked();
	}
  	
	protected ImageIcon createImageIcon(String path) {
		java.net.URL imgURL = CheckNodeTreeExample.class.getResource(path);
		if (imgURL != null) {
			return new ImageIcon(imgURL);
		} else {
			System.err.println("Couldn't find file: " + path);
			return null;
		}
	}
	
	public void actionPerformed(ActionEvent e) {
	}
  }


