package archstudio.comp.cake;

public interface CheckNodeTreeWrapper {

  //Adds a layer with the specified name, ID and type. The new layer is added
  //to the version specified by versionID
  public void addLayer(String name, String nodeID, int layerType, String versionID);

  //Adds a new version with the specified name and nodeID
  public void addVersion(String name, String nodeID);
  
  //Removes the layer with the specified layerID
  public void removeLayer(String nodeID);

  //Removes the version with the specified nodeID
  public void removeVersion(String nodeID);
  
  //Returns the name of the layer that has the given nodeID
  public String getName(String nodeID);
  
  //Sets the name of the node specified by the id to the name specified
  public void setName(String name, String nodeID);

}
  