package archstudio.comp.cake;

/*  swing1.1 */
 

//import java.io.*;
import java.awt.*;
//import java.awt.event.*;
import java.awt.Color;
import javax.swing.*;
import javax.swing.tree.*;
import javax.swing.plaf.ColorUIResource;


/**
 * @version 1.0 01/11/99
 */
public class CheckRenderer extends JPanel implements TreeCellRenderer {
  protected JCheckBox check;
  protected JCheckBox check2;
  protected TreeLabel label;
  protected CheckNode node;
  protected Color color;
  protected boolean isVersion;
  protected int type;
  
  int BUFFER = 20;
  static int COLUMN1 = 125;
  int COLUMN2 = COLUMN1 + new JCheckBox().getPreferredSize().width;
  
  public static int getColumnX(){
  	return COLUMN1;
  }
  
  //boolean leaf = false;
  int row = -1; 
  
  public CheckRenderer() {
    setLayout(null);
	add(label = new TreeLabel());
    add(check = new JCheckBox());
	add(check2 = new JCheckBox());
    check.setBackground(UIManager.getColor("Tree.textBackground"));
	check2.setBackground(UIManager.getColor("Tree.textBackground"));
  }

  public Component getTreeCellRendererComponent(JTree tree, Object value,
               boolean isSelected, boolean expanded,
               boolean tempLeaf, int tempRow, boolean hasFocus) {
    String  stringValue = tree.convertValueToText(value, isSelected,
			expanded, tempLeaf, tempRow, hasFocus);
    setEnabled(tree.isEnabled());
    check.setSelected(((CheckNode)value).isSelected());
	check2.setSelected(((CheckNode)value).isSelected2());
	
	//Add bold font
	Font f = tree.getFont();
	label.setFont(f.deriveFont(f.getStyle() ^ Font.BOLD));
	
    label.setText(stringValue);
    label.setSelected(isSelected);
    label.setFocus(hasFocus);
    
    //Get access to this node
    row = tempRow;
    //System.out.println(value);
    TreePath path = tree.getPathForRow(row);
    color = Color.BLACK;
    
    //Assuming that we are dealing with a valid node
    if(path != null){
		node = ((CheckNode)path.getLastPathComponent());
    
        //Set this node's color based on its version
		color = node.getColor();
		label.setForeground(color);
    
    	//Find out if it is a version
    	isVersion = node.getIsVersion();
		type = node.getType();
	}
	
    //Draw it appropriately
    if (!isVersion) {
	  label.setIcon(createImageIcon("img\\layer_comp.gif"));
	  if(type == CheckNode.CONNECTOR_LAYER){
		label.setIcon(createImageIcon("img\\layer_con.gif"));
	  }
	  if(type == CheckNode.LINK_LAYER){
		label.setIcon(createImageIcon("img\\layer_link.gif"));
	  }
	  if(type == CheckNode.ANNOTATION_LAYER){
		label.setIcon(createImageIcon("img\\layer_ann.gif"));
	  } 
    } else if (expanded) {
      label.setIcon(UIManager.getIcon("Tree.openIcon"));
    } else {
      label.setIcon(UIManager.getIcon("Tree.closedIcon"));
    }	    
    return this;
  }
  
  public Dimension getPreferredSize() {
    Dimension d_check = check.getPreferredSize();
	Dimension d_check2 = check2.getPreferredSize();
    Dimension d_label = label.getPreferredSize();
	int tempBuffer = 0;
	if(isVersion){
		tempBuffer = BUFFER;
	}    
    return new Dimension(tempBuffer + COLUMN2 + d_check2.width,
      (d_check.height < d_label.height ?
       d_label.height : d_check.height));
  }
  
  public void doLayout() {
    Dimension d_check = check.getPreferredSize();
	Dimension d_check2 = check2.getPreferredSize();
    Dimension d_label = label.getPreferredSize();
    int y_check = 0;
	int y_check2 = 0;
    int y_label = 0;
    if (d_check.height < d_label.height) {
      y_check = (d_label.height - d_check.height)/2;
	  y_check2 = (d_label.height - d_check.height)/2;
    } else {
      y_label = (d_check.height - d_label.height)/2;
    }
    
    int tempBuffer = 0;
    if(isVersion){
    	tempBuffer = BUFFER;
    } 
   
    
    label.setLocation(0,y_label);   
    label.setBounds(0,y_label,d_label.width,d_label.height);
	check.setLocation(tempBuffer + COLUMN1,y_check);
	check.setBounds(tempBuffer + COLUMN1,y_check,d_check.width,d_check.height);
	check2.setLocation(tempBuffer + COLUMN2,y_check2);
	check2.setBounds(tempBuffer + COLUMN2,y_check2,d_check2.width,d_check2.height);    
  }
   
  
  public void setBackground(Color color) {
    if (color instanceof ColorUIResource)
      color = null;
    super.setBackground(color);
  }
  
  protected ImageIcon createImageIcon(String path) {
	  java.net.URL imgURL = CheckNodeTreeExample.class.getResource(path);
	  if (imgURL != null) {
		  return new ImageIcon(imgURL);
	  } else {
		  System.err.println("Couldn't find file: " + path);
		  return null;
	  }
  }
  
    
  class TreeLabel extends JLabel {
    boolean isSelected;
    boolean hasFocus;
    
    TreeLabel() {
    }
        
    public void setBackground(Color color) {
	if(color instanceof ColorUIResource)
	    color = null;
	super.setBackground(color);
    } 
         
    public void paint(Graphics g) {
      String str;
      if ((str = getText()) != null) {
        if (0 < str.length()) {
          if (isSelected) {
            g.setColor(UIManager.getColor("Tree.selectionBackground"));
          } else {
            g.setColor(UIManager.getColor("Tree.textBackground"));
          }
          Dimension d = getPreferredSize();
          int imageOffset = 0;
          Icon currentI = getIcon();
          if (currentI != null) {
            imageOffset = currentI.getIconWidth() + Math.max(0, getIconTextGap() - 1);
          }
          g.fillRect(imageOffset, 0, d.width -1 - imageOffset, d.height);
          if (hasFocus) {
            g.setColor(UIManager.getColor("Tree.selectionBorderColor"));
            g.drawRect(imageOffset, 0, d.width -1 - imageOffset, d.height -1);     
         }
        }
      }
      super.paint(g);
    }
  
    public Dimension getPreferredSize() {
      Dimension retDimension = super.getPreferredSize();
      if (retDimension != null) {
        retDimension = new Dimension(retDimension.width + 3,
				 retDimension.height);
      }
      return retDimension;
    }
    
    void setSelected(boolean isSelected) {
      this.isSelected = isSelected;
    }
    
    void setFocus(boolean hasFocus) {
      this.hasFocus = hasFocus;
    }
  }
}    
