/*
 * Created on May 29, 2004
 *
 */
package archstudio.comp.cake;

import edu.uci.ics.bna.Thing;

/**
 * @author Chris
 *
 * Interface for Things that can be drawn on a layer. Things that are layerable can be either visible (on their
 * respective layer) or editable (can be selected and have other such related properties changed).
 */
public interface ILayerableThing extends Thing
{
	public static final String VISIBLE_PROPERTY_NAME = "visible";
	public static final String EDITABLE_PROPERTY_NAME = "editable";
	public static final String LAYER_PROPERTY_NAME = "layer";
	public static final String VERSION_PROPERTY_NAME = "version";
	
	public void setVisible(boolean visible);
	public boolean isVisible();
	
	public void setEditable(boolean editable);
	public boolean isEditable();
	
	public void setLayer(String layerName);
	public String getLayer();
	
	public void setVersion(String versionName);
	public String getVersion();
	
	/**
	 * This function returns true if and only if the thing is part of a layer
	 * directly (such as a component, connector, link or annotation).
	 * @return
	 */
	public boolean hasOwnLayerType();
}
