/*
 * Created on Jun 2, 2004
 *
 */
package archstudio.comp.cake;

import java.awt.Color;
import java.util.Collections;
import java.util.HashMap;

import edu.uci.ics.bna.FloatingLabel;
import edu.uci.ics.bna.GlassableThing;
import edu.uci.ics.bna.IndicatorThing;

/**
 * @author Chris
 *
 */
public class LayerableFloatingLabel extends FloatingLabel implements ILayerableThing, IndicatorThing, 
	GlassableThing
{

	/**
	 * 
	 */
	public LayerableFloatingLabel()
	{
		super();
		setEditable(true);
		setVisible(true);
		setTrimColor(Color.BLACK);
		//setGlassed(true);
		//setGlassedTransparency(1.00f);
	}
	
	protected LayerableFloatingLabel(ILayerableThing copyMe)
	{
		this.id = copyMe.getID();
		this.props = Collections.synchronizedMap(new HashMap(copyMe.getPropertyMap()));
		this.propertyLockObject = props;
	}

	public Object clone() throws CloneNotSupportedException
	{
		ILayerableThing m = new LayerableFloatingLabel(this);
		return m;
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#setVisible(boolean)
	 */
	public void setVisible(boolean visible)
	{
		setProperty(VISIBLE_PROPERTY_NAME, visible);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#isVisible()
	 */
	public boolean isVisible()
	{
		return getBooleanProperty(VISIBLE_PROPERTY_NAME);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#setEditable(boolean)
	 */
	public void setEditable(boolean editable)
	{
		setProperty(EDITABLE_PROPERTY_NAME, editable);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#isEditable()
	 */
	public boolean isEditable()
	{
		return getBooleanProperty(EDITABLE_PROPERTY_NAME);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#setLayer(java.lang.String)
	 */
	public void setLayer(String layerName)
	{
		setProperty(LAYER_PROPERTY_NAME, layerName);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#getLayer()
	 */
	public String getLayer()
	{
		return (String)getProperty(LAYER_PROPERTY_NAME);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#setVersion(java.lang.String)
	 */
	public void setVersion(String versionName)
	{
		setProperty(VERSION_PROPERTY_NAME, versionName);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#getVersion()
	 */
	public String getVersion()
	{
		return (String)getProperty(VERSION_PROPERTY_NAME);
	}

	public String getPeerClassname()
	{
		return "archstudio.comp.cake.LayerableFloatingLabelPeer";
	}

	public void setIndicatorPoint(java.awt.Point indicatorPoint)
	{
		setProperty(IndicatorThing.INDICATOR_POINT_PROPERTY_NAME, indicatorPoint);
	}
	
	public java.awt.Point getIndicatorPoint()
	{
		return (java.awt.Point) getProperty(IndicatorThing.INDICATOR_POINT_PROPERTY_NAME);
	}
	
	public void setIndicatorThingId(String indicatorThingId)
	{
		setProperty(IndicatorThing.INDICATOR_THING_ID_PROPERTY_NAME, indicatorThingId);
	}
	
	public String getIndicatorThingId()
	{
		return (String)getProperty(IndicatorThing.INDICATOR_THING_ID_PROPERTY_NAME);
	}
	
	public int getX()
	{		
		return super.getX();
	}
	
	public int getX2()
	{
		return super.getX() + getWidth();
	}
	
	public int getY()
	{
		return super.getY();
	}
	
	public int getY2()
	{
		return super.getY() + getHeight();
	}
	
	public void setWidth(int width)
	{
		setProperty("#width", width);
	}
	
	public int getWidth()
	{
		return getIntProperty("#width");
	}
	
	public void setHeight(int height)
	{
		setProperty("#height", height);
	}
	
	public int getHeight()
	{
		return getIntProperty("#height");
	}
	
	public void setTrimColor(Color color)
	{
		setProperty("trimcolor", color);
	}
	
	public Color getTrimColor()
	{
		return (Color)getProperty("trimcolor");
	}
	
	public void setGlassed(boolean glassed)
	{
		setProperty(GLASSED_PROPERTY_NAME, glassed);
	}
	
	public boolean isGlassed()
	{
		return getBooleanProperty(GLASSED_PROPERTY_NAME);
	}
	
	public void setGlassedTransparency(float transparency)
	{
		setProperty(GLASSED_TRANSPARENCY_PROPERTY_NAME, transparency);
	}
	
	public float getGlassedTransparency()
	{
		return getFloatProperty(GLASSED_TRANSPARENCY_PROPERTY_NAME);
	}
	
	public boolean hasOwnLayerType()
	{
		return true;
	}
}
