/*
 * Created on Jun 3, 2004
 *
 * LayerableRectSpline.java
 */
package archstudio.comp.cake;

import java.util.Collections;
import java.util.HashMap;

import edu.uci.ics.bna.RectSpline;

/**
 * @author Ping
 *
 * This class extends the basic RectSpline thing and implements
 * the basic layer visibility and editability.
 */
public class LayerableRectSpline extends RectSpline implements ILayerableThing
{
	/**
	 * 
	 */
	public LayerableRectSpline()
	{
		super();
		setVisible(true);
		setEditable(true);
	}
	
	protected LayerableRectSpline(ILayerableThing copyMe)
	{
		this.id = copyMe.getID();
		this.props = Collections.synchronizedMap(new HashMap(copyMe.getPropertyMap()));
		this.propertyLockObject = props;
	}

	public Object clone() throws CloneNotSupportedException
	{
		ILayerableThing m = new LayerableRectSpline(this);
		return m;
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#setVisible(boolean)
	 */
	public void setVisible(boolean visible)
	{
		setProperty(VISIBLE_PROPERTY_NAME, visible);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#isVisible()
	 */
	public boolean isVisible()
	{
		return getBooleanProperty(VISIBLE_PROPERTY_NAME);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#setEditable(boolean)
	 */
	public void setEditable(boolean editable)
	{
		setProperty(EDITABLE_PROPERTY_NAME, editable);
	}

	/* (non-Javadoc)
	 * @see archstudio.comp.cake.ILayerableThing#isEditable()
	 */
	public boolean isEditable()
	{
		return getBooleanProperty(EDITABLE_PROPERTY_NAME);
	}

	public void setLayer(String layerName)
	{
		setProperty(LAYER_PROPERTY_NAME, layerName);
	}
	public String getLayer()
	{
		return (String)getProperty(LAYER_PROPERTY_NAME);
	}

	public void setVersion(String versionName)
	{
		setProperty(VERSION_PROPERTY_NAME, versionName);
	}
	public String getVersion()
	{
		return (String)getProperty(VERSION_PROPERTY_NAME);
	}

	public String getPeerClassname()
	{
		return "archstudio.comp.cake.LayerableRectSplinePeer";
	}
	
	public boolean hasOwnLayerType()
	{
		return true;
	}
}
