/*
 * Created on Jun 3, 2004
 *
 * LayerableRectSplinePeer.java
 */
package archstudio.comp.cake;

import java.awt.Graphics2D;

import edu.uci.ics.bna.*;

/**
 * @author Ping
 *
 * This extends the basic RectSpline peer such that the spline is only drawn
 * when its visible.
 */
public class LayerableRectSplinePeer extends RectSplinePeer
{
	private LayerableRectSpline layerableSpline;
	
	public LayerableRectSplinePeer(BNAComponent c, Thing t)
	{
		super(c, t);
	
		//System.out.println("Thing type is: " + t.getClass());
		if(!(t instanceof LayerableRectSpline))
		{
			throw new IllegalArgumentException("LayerableRectSplinePeer can only be a peer " +
				"for a LayerableRectSpline");
		}

		layerableSpline = (LayerableRectSpline)t;
	}

	public void draw(Graphics2D g, CoordinateMapper cm)
	{
		if(layerableSpline.isVisible())
		{
			super.draw(g, cm);
		}
	}
}
