/*
 * Created on Jun 1, 2004
 *
 * LayeredDragMovableSelectionLogic.java
 */
package archstudio.comp.cake;

import java.awt.event.MouseEvent;

import edu.uci.ics.bna.*;

/**
 * @author Ping
 *
 * This extends the basic DragMovableSelectionLogic to handle layered elements.
 * Something can only be grabbed (dragged) if its editable.
 */
public class LayeredDragMovableSelectionLogic extends DragMovableSelectionLogic
{
	protected ModeTrackingLogic modeTrackingLogic;
	
	public LayeredDragMovableSelectionLogic(ModeTrackingLogic mtl)
	{
		this.modeTrackingLogic = mtl;
	}
	
	// If the thing can't be editable, then we can never pick it up/grab it in 
	// in the first place.
	public void mousePressed(Thing t, MouseEvent evt, int worldX, int worldY)
	{
		if(modeTrackingLogic.getMode() == Palette.ADD_MODE || 
		   modeTrackingLogic.getMode() == Palette.SELECT_MODE)
		{
			//System.out.println("mousePressed");
			if(t instanceof ILayerableThing)
			{
				ILayerableThing layeredThing = (ILayerableThing)t;
				
				if(!layeredThing.isEditable())
				{
					// if the thing is layered thing and is NOT editable
					// we exit because its you can't grab it!
					return;
				}
			}
			//System.out.println("Something was grabbed");
			super.mousePressed(t, evt, worldX, worldY);
		}
	}
}
