/*
 * Created on Jun 2, 2004
 *
 * LayeredMoveEndpointLogic.java
 */
package archstudio.comp.cake;

import java.awt.event.MouseEvent;

import edu.uci.ics.bna.*;

/**
 * @author Ping
 *
 * This class extends the basic MoveEndpointLogic by not letting
 * the endpoint be grabbed  if it was not editable.
 */
public class LayeredMoveEndpointLogic extends MoveEndpointLogic
{
	protected ModeTrackingLogic modeTrackingLogic;
	
	public LayeredMoveEndpointLogic(
		BoundingBoxTrackingLogic boundingBoxTrackingLogic,
		ModeTrackingLogic mtl)
	{
		super(boundingBoxTrackingLogic);
		this.modeTrackingLogic = mtl;
	}

	public void mousePressed(Thing t, MouseEvent evt, 
		int worldX, int worldY)
	{
		if(modeTrackingLogic.getMode() == Palette.ADD_MODE || 
		   modeTrackingLogic.getMode() == Palette.SELECT_MODE)
		{
			if(t instanceof ILayerableThing)
			{
				//System.out.println("Trying to grab an layered thing");
				ILayerableThing layeredThing = (ILayerableThing)t;
				if(!layeredThing.isEditable())
				{
					// if its not editable, don't process it
					//System.out.println("Its not editable dummy!");
					return;				
				}
			}
			super.mousePressed(t, evt, worldX, worldY);
		}
	}
}
