/*
 * Created on Jun 1, 2004
 *
 * LayeredOneClickSelectionLogic.java
 */
package archstudio.comp.cake;

import edu.uci.ics.bna.*;
import java.awt.event.*;

/**
 * @author Ping
 *
 * This class extends the basic selection logic such that an element
 * can only be selected if its editable.
 */
public class LayeredOneClickSelectionLogic extends OneClickSelectionLogic
{
	protected ModeTrackingLogic modeTrackingLogic;
	
	public LayeredOneClickSelectionLogic(ModeTrackingLogic mtl)
	{
		this.modeTrackingLogic = mtl;
	}
	
	public void mouseClicked(Thing t, MouseEvent evt, int worldX, int worldY)
	{
		// process only when we are in add and select mode
		if(modeTrackingLogic.getMode() == Palette.ADD_MODE || 
		   modeTrackingLogic.getMode() == Palette.SELECT_MODE)
		{
			if(t instanceof ILayerableThing)
			{
				ILayerableThing layeredThing = (ILayerableThing)t;
				if(!layeredThing.isEditable())
				{
					// if its not editable, don't process it
					return;				
				}
			}
			super.mouseClicked(t, evt, worldX, worldY);
		}
	}
}
