/*
 * Created on Jun 2, 2004
 *
 * LayeredSelectionBasedContextMenuLogic.java
 */
package archstudio.comp.cake;

import javax.swing.*;


import edu.uci.ics.bna.*;
import edu.uci.ics.bna.contextmenu.SelectionBasedContextMenuLogic;
/**
 * @author Ping
 *
 * This class extends the basic context menu logic by creating a 
 * context menu with a single "This element is not editable" option
 * when creating a popup menu for non-editable Things.
 */
public class LayeredSelectionBasedContextMenuLogic
	extends SelectionBasedContextMenuLogic
{
	public LayeredSelectionBasedContextMenuLogic(SelectionTrackingLogic stl)
	{
		super(stl);
	}
	
	/*
	protected void checkAndDoPopup(Thing t, MouseEvent evt, int worldX, int worldY)
	{
		if(t != null && t instanceof ILayerableThing)
		{
			ILayerableThing layerableThing = (ILayerableThing)t;
			
			if(!layerableThing.isEditable())
			{
				// its not editable, so we don't need a popup menu for it
				// so just return, don't do popup.
				return;
			}
		}
		super.checkAndDoPopup(t, evt, worldX, worldY);
	}
	*/
	public JPopupMenu getContextMenu(Thing t, int worldX, int worldY) 
	{
		
		if(t != null && t instanceof ILayerableThing)
		{
			ILayerableThing layerableThing = (ILayerableThing)t;
	
			if(!layerableThing.isEditable())
			{
				// its not editable, so we don't need a popup menu for it
				// create a dummy place holder
				JPopupMenu popupMenu = new JPopupMenu();
				JMenuItem miNone = 
					new JMenuItem("[This element is not editable]");
				miNone.setEnabled(false);
				popupMenu.add(miNone);
				
				if(t instanceof SelectableThing)
				{
					// make sure its unseletected
					// the element might be selected
					// as a result of right clicking on it....
					SelectableThing sThing = (SelectableThing)t;
					sThing.setSelected(false);
				}
				return popupMenu;
			}
		}
		// otherwise, call the default menu creation stuff
		return super.getContextMenu(t, worldX, worldY);
	}
}
