/*
 * Created on Jun 4, 2004
 *
 * LayeredSplineReshapeLogic.java
 */
package archstudio.comp.cake;

import java.awt.event.MouseEvent;

import edu.uci.ics.bna.*;

/**
 * @author Ping
 *
 * This class handles the basic layered spline editing functions.  Makes
 * sure you can't edit a non-editable spline.
 */
public class LayeredSplineReshapeLogic extends SplineReshapeLogic
{
	protected ModeTrackingLogic modeTrackingLogic;
	
	public LayeredSplineReshapeLogic(SelectionTrackingLogic selectionTrackingLogic,
		ModeTrackingLogic mtl)
	{
		super(selectionTrackingLogic);
		this.modeTrackingLogic = mtl;
	}
	
	public void mousePressed(Thing t, MouseEvent evt, int worldX, int worldY)
	{
		if(modeTrackingLogic.getMode() == Palette.ADD_MODE || 
		   modeTrackingLogic.getMode() == Palette.SELECT_MODE)
		{
			if(t instanceof ILayerableThing)
			{
				ILayerableThing layeredThing = (ILayerableThing)t;
				if(!layeredThing.isEditable())
				{
					// if its not editable, don't process it
					return;				
				}
			}
			super.mousePressed(t, evt, worldX, worldY);
		}
	}
	
	public void mouseClicked(Thing t, MouseEvent evt, int worldX, int worldY)
	{
		if(modeTrackingLogic.getMode() == Palette.ADD_MODE ||
		   modeTrackingLogic.getMode() == Palette.SELECT_MODE)
		{
			if(t instanceof ILayerableThing)
			{
				ILayerableThing layeredThing = (ILayerableThing)t;
				if(!layeredThing.isEditable())
				{
					// if its not editable, don't process it
					return;				
				}
			}
			super.mouseClicked(t, evt, worldX, worldY);
		}
	}
}
