/*
 * Created on Jun 2, 2004
 *
 * LayeredToolTipLogic.java
 */
package archstudio.comp.cake;

import edu.uci.ics.bna.*;
import java.awt.event.MouseEvent;
/**
 * @author Ping
 *
 * This class enhances the basic ToolTipLogic by not processing the tooltip
 * for Things that are not visible.
 */
public class LayeredToolTipLogic extends ToolTipLogic{

	public void mouseMoved(Thing t, MouseEvent evt, int worldX, int worldY)
	{
		
		//System.out.println("mousePressed");
		if(t != null && t instanceof ILayerableThing)
		{
			ILayerableThing layeredThing = (ILayerableThing)t;
			
			if(!layeredThing.isVisible())
			{
				// if the thing is layered thing and is NOT visible
				// we exit.  No tool tip should be displayed
				return;
			}
		}
		super.mouseMoved(t, evt, worldX, worldY);
	}
}
