/*
 * Created on Jun 6, 2004
 *
 * ModeTrackingLogic.java
 */
package archstudio.comp.cake;

import java.util.Iterator;

import edu.uci.ics.bna.*;

/**
 * @author Ping
 *
 * This logic keeps track of the mode of Cake (add, select, remove)
 */
public class ModeTrackingLogic extends ThingLogicAdapter
{
	protected int mode = Palette.ADD_MODE;
	
	public int getMode()
	{
		return mode;
	}
	
	public void bnaModelChanged(BNAModelEvent evt)
	{
		Thing t = evt.getTargetThing();
		if((t != null) && (t instanceof Palette))
		{
			Palette palette = (Palette)t;
			ThingEvent thingEvent = evt.getThingEvent();
			if(thingEvent != null)
			{
				// find out the name of property that was changed
				String propertyName = thingEvent.getPropertyName();
				if(propertyName != null)
				{
					if(propertyName.equals(Palette.MODE_PROPERTY_NAME))
					{
						int newMode = palette.getMode();
						if(mode != Palette.REMOVE_MODE &&
						   newMode == Palette.REMOVE_MODE)
						{
							// we went from a non-remove mode to
							// remove mode.  So unselect all the things.
							unselectThings();
						}
						mode = newMode;
					}
				}
			}
		}
	}
	// This function will go through and unselect all the things that
	// were selected
	protected void unselectThings()
	{
		for(Iterator it = bnaComponent.getModel().getThingIterator(); it.hasNext(); )
		{
			Thing t = (Thing)it.next();
			if(t instanceof SelectableThing)
			{
				((SelectableThing)t).setSelected(false);
			}
		}
	}
}
