/*
 * Created on Jun 6, 2004
 *
 * PaletteWindowHeaderPanel.java
 */
package archstudio.comp.cake;

import java.awt.*;
import javax.swing.*;


/**
 * @author Ping
 *
 * This class provides the implementation for the window header panel
 * for the palette.
 */
public class PaletteWindowHeaderPanel extends JPanel
{
	protected JLabel titleLabel;
	public PaletteWindowHeaderPanel(String title)
	{
		super();
		titleLabel = new JLabel();
		
		this.setLayout(new BorderLayout());
		
		JPanel labelPanel = new JPanel();
		labelPanel.setOpaque(false);
		labelPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
		labelPanel.add(titleLabel);
		
		JPanel buttonPanel = new JPanel();
		buttonPanel.setOpaque(false);
		buttonPanel.setLayout(new FlowLayout(FlowLayout.RIGHT));
		
		this.add("Center", labelPanel);
		
		//this.setDebugGraphicsOptions(DebugGraphics.LOG_OPTION);
		setTitle(title);
	}
	
	public void paintComponent(Graphics g)
	{
		Graphics2D g2d = (Graphics2D)g;
		Rectangle bounds = getVisibleRect();
		bounds.width--;
		bounds.height--;
		
		Paint oldPaint = g2d.getPaint();
		
		g2d.setPaint(new GradientPaint(bounds.x, bounds.y, Color.LIGHT_GRAY.brighter(), bounds.x, bounds.y + bounds.height, Color.GRAY));
		g2d.fill(bounds);
		
		g2d.setColor(Color.BLACK);
		//g2d.setPaint(Color.BLACK);
		//g2d.draw(bounds);
		g2d.drawLine(bounds.x, bounds.y + bounds.height, bounds.x + bounds.width, bounds.y + bounds.height);
		g2d.setPaint(oldPaint);
	}
	
	
	public void setTitle(String title)
	{
		titleLabel.setText(title);
	}
	
	public String getTitle()
	{
		return titleLabel.getText();
	}
}
